#pragma once

#include <stdlib.h>
#include <memory.h>

	const unsigned short difftableQMG[256] = {
          1,         3,     0x100,         2,         8,	    7,         6,     0x300,
		  0x10,      4,     0x200,         9,      0x40,      0x18,         5,     0x20,
		  0xC,     0xE,       0xF,       0xA,      0xC0,     0x800,     0x700,     0x101,
		  0x400,      0xB,      0x30,      0x11,      0x80,     0x600,    0xD,      0x12,
		  0x1C,     0x500,      0x1B,     0x1E,      0x14,      0x1A,      0x28,     0x38,
     0x1000,      0x1F,      0x19,      0x16,      0x60,   0x2000,      0x13,      0x1D,     0x103,      0x24,
       0x17,      0x15,     0x102,     0x1C0,     0xF00,     0x3C,     0x301,     0xC00,    0x1800,      0x48,
       0x21,      0x34,     0xE00,     0x202,      0x2C,     0x70,     0xA00,     0x303,      0x36,     0x201,
       0x3F,     0xD00,     0x180,      0x3E,    0x3000,    0x900,      0x78,      0x22,      0x50,      0x3A,
       0x41,     0x107,      0x33,     0x106,      0x26,     0x2A,      0xA0,      0x23,      0x29,      0x88,
       0x44,      0x3D,      0xE0,      0x32,      0x2E,     0x39,      0x31,      0x2D,      0xF0,     0x140,
      0xB00,      0x3B,      0x58,    0x4000,      0x37,     0x35,      0x68,     0x302,      0x7C,      0x2F,
       0x27,      0x64,      0x90,      0x74,     0x203,    0x104,      0x6C,    0x1100,     0x3C0,      0xFF,
       0x25,    0xF000,    0x1F00,     0x701,      0x42,     0x7F,      0x2B,     0x105,      0x54,    0x1C00,
       0x4C,     0x801,      0x43,    0x6000,      0x5C,     0x7E,      0xE8,     0x108,      0xF8,    0xE000,
      0x206,    0x1E00,     0x380,      0x61,      0x7A,     0x4E,     0x601,    0x1001,      0xC8,    0x8000,
     0x1D00,      0xD0,      0x72,      0x49,    0x1600,   0x1A00,      0x46,    0x7000,     0x10F,     0x110,
       0x76,    0x1200,    0x1400,     0x404,     0x606,    0x10E,      0xFC,    0x1700,      0x6E,      0xFE,
     0x1300,      0x62,      0x66,    0xC000,     0x204,    0x306,      0x63,     0x707,     0x280,     0x602,
       0x55,      0x47,      0x6A,     0x10C,      0x52,    0x501,      0xD8,     0x307,      0x73,     0x109,
      0x808,     0x401,      0x4A,    0x2020,      0x5A,    0x702,      0xB0,      0x45,     0x207,     0x304,
      0x402,      0x5E,     0x10A,      0x79,    0x3800,     0xF4,    0x1500,     0x1E0,    0x1B00,      0x71,
     0x1010,      0xC1,      0xE4,     0x502,      0x56,     0x7D,      0x81,      0x77,      0xCC,     0x703,
      0x10D,     0x205,     0x340,    0x5000,      0x82,     0x67,    0xFF00,     0x120,      0x69,      0x98,
       0xC3,    0x1900,      0x65,      0x7B,     0x240,    0x603,      0xEC,      0x59,      0xFA,     0x403,
       0x75,      0x6F,    0x3100,    0x3300,      0x4F,     0xB8,      0x6D,     0x208,      0x4D,     0x111,
       0x51,     0x20E,      0xDC,      0xC4,    0x2100,     0xA8
};

namespace ImageUtils
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::IO;
	using namespace System::Runtime::InteropServices;


int  QM_WCodec_2nd_decode( unsigned char * source, unsigned char *dest){
	
	/*unsigned */short offset_;
	/*signed */ int v2; // ebx@1 
	unsigned int BitsBuffer; // edi@1 
	unsigned int len1; // ecx@1 
	unsigned char* len2; // ebx@1 
	/*unsigned*/ int v7; // eax@2 
	unsigned int BitCount; // ebx@3 
//	signed int v9;
	unsigned char *pDest;
	unsigned int v28;
	/*unsigned */short v44; // eax@58 
	unsigned int result; // eax@63 
	unsigned int v47; // eax@64 
	unsigned int v48;
	void *v58;
	unsigned int v86; // [sp+10h] [bp-28h]@1 
	unsigned char *pIn; // [sp+1Ch] [bp-1Ch]@1 
	unsigned char *pBlock2; // [sp+20h] [bp-18h]@1 
	unsigned char * pBlock1; // [sp+24h] [bp-14h]@1 
	int first; // [sp+28h] [bp-10h]@1 
	
	signed char Shift;	
	
	offset_ = 1;
	BitsBuffer = 0; 
	
	first = *(unsigned char *)source | (*(unsigned char *)(source + 1) << 8) | (*(unsigned char *)(source + 2) << 16) | (*(unsigned char *)(source + 3) << 24); 
	len1 = *(unsigned char *)(source + 4) | (*(unsigned char *)(source + 5) << 8) | (*(unsigned char *)(source + 6) << 16) | (*(unsigned char *)(source + 7) << 24); 
	len2 = (unsigned char *)((*(unsigned char *)(source + 8) | (*(unsigned char *)(source + 9) << 8) | (*(unsigned char *)(source + 10) << 16) | (*(unsigned char *)(source + 11) << 24)) + len1 + (unsigned char *)source); 

	pBlock1 = (unsigned char *)(source + 12); 
	pBlock2 = (unsigned char *)(len1 + (unsigned char *)(source + 12)); 

	int CountDword = (first & 0xFFFFFFF0) >> 2;

	pDest = dest + 4; 
	memcpy(dest, (len2 + 12), 4); 

	pIn = (unsigned char *)(len2 + 16);

	v2 = 16; 
	do {
		//v7 = *(unsigned char *)pBlock1++; 
		BitsBuffer = *(unsigned char *)pBlock1++ | (BitsBuffer << 8);
		v2 -= 8;
	} while ( v2 >= 0 ); 

	BitCount = 24; 
///////////////////////////////////////


	for(int i = 0; i < 3; i++){

	BitCount--;
	if ( !(BitsBuffer & 0x800000) ) 
	{ 
		BitCount--;
			if ( BitsBuffer & 0x400000 ) 
			{
				offset_ = *(unsigned char *)pBlock2++; 
				//pBlock2 = (unsigned char *)pBlock2 + 1;
			} else {
			
				offset_ = *(unsigned short *)pIn; 
				pIn += 2;//(unsigned char *)pIn + 2; 
			} 
	}



	BitCount --;
	if ( (BitsBuffer >> BitCount) & 1 ) 
	{
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
	} else {
		BitCount--;
				if ( (BitsBuffer >> BitCount) & 1 ) 
				{
				*(unsigned short *)pDest = *(unsigned short *)pIn; 
				pIn += 2;//(unsigned char *)pIn + 2;
				} else { 

					*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);
					//pBlock2 = (unsigned char *)pBlock2 + 1;

				}
	}
	pDest+=2;// = dest + 6;

	BitCount--; 
	if ( (BitsBuffer >> BitCount) & 1 ) 
	{
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
	} else {
		BitCount--;
		if ( (BitsBuffer >> BitCount) & 1 ) 
		{
			*(unsigned short *)pDest = *(unsigned short *)pIn; 
			pIn += 2;//(unsigned char *)pIn + 2;
		} else { 
			*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);
			//pBlock2 = (unsigned char *)pBlock2 + 1;
		
		}
	}
	
	pDest+=2;// = dest + 8; 

	}


unsigned int Count = 4; 

while ( Count < CountDword )
{
	while(BitCount < 2){
		BitsBuffer = *(unsigned char *)pBlock1++ | (BitsBuffer << 8);
			BitCount += 8;
	}

	BitCount--;// = BitCount - 1;
	if ( !((BitsBuffer >> BitCount) & 1) )
	{
		BitCount--;// = BitCount - 1; 
		if ( !((BitsBuffer >> BitCount) & 1) )
		{
			memcpy((void *)pDest, pIn, 0x10); 
			pDest += 0x10;
			pIn += 0x10;//= (unsigned char *)pIn + 16; 
			goto LABEL_61;
		}
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		pDest +=2;
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		pDest += 2;
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_);
		pDest += 2;
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		pDest += 2;
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		pDest += 2; 
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		pDest += 2;
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_);
		pDest += 2;
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		pDest += 2;

		
		goto LABEL_61;
	}




	Shift = *(unsigned char *)pBlock2++;
	
	while ( BitCount < 0xF ) 
	{
		BitsBuffer = *(unsigned char *)pBlock1++ | (BitsBuffer << 8);
		BitCount += 8;
	}

	BitCount--;
	if ( (BitsBuffer >> BitCount) & 1 ) 
		goto LABEL_33;
	
	BitCount--; 
	if ( (BitsBuffer >> BitCount) & 1 )
	{
		offset_ = *(unsigned char *)pBlock2++; 
LABEL_33: 
		if ( Shift /*< 0*/ & 0x80 ) // 8 bit 
			goto LABEL_88;
		goto LABEL_34;
	}
	offset_ = *(unsigned short *)pIn;
	pIn += 2;

	if ( Shift /*< 0*/ & 0x80 )// 8 bit
	{
LABEL_88:
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		goto LABEL_36;
	}
LABEL_34:
	BitCount--; 
	if ( (BitsBuffer >> BitCount) & 1 ) 
	{
		*(unsigned short *)pDest = *(unsigned short *)pIn; 
		pIn += 2;
	} else { 
	
		*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_); 
	}
LABEL_36:
	pDest += 2;
	if ( Shift & 0x40 ) //7 bit
	{
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_);
	} else {
		BitCount--;
		if ( (BitsBuffer >> BitCount) & 1 )
		{ 
		*(unsigned short *)pDest = *(unsigned short *)pIn; 
		pIn += 2;
		} else {
			
			*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);
		}
	}
	BitCount --;
	pDest += 2;
	if ( !((BitsBuffer >> BitCount) & 1) ) 
	{
		BitCount--;
		if ( (BitsBuffer >> BitCount) & 1 ) 
		{
			offset_ = *(unsigned char *)pBlock2++; 
			
		} else { 
			offset_ = *(unsigned short *)pIn;
			pIn += 2;
		}
	}
	if ( Shift & 0x20 )// 6 bit
	{
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_); 
		goto LABEL_43;
	}
	BitCount--;
	if ( !((BitsBuffer >> BitCount) & 1) ) 
	{
		
		*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);

LABEL_43:
		pDest += 2;



		if ( !(Shift & 0x10) )//5 bit
			goto LABEL_75;
		goto LABEL_44; 
	}
	*(unsigned short *)pDest = *(unsigned short *)pIn; 
	pIn = (unsigned char *)pIn + 2;

	pDest += 2;

	if ( !(Shift & 0x10) )
	{
LABEL_75:
		BitCount--; 
		if ( (BitsBuffer >> BitCount) & 1 )
		{
			*(unsigned short *)pDest = *(unsigned short *)pIn; 
			pIn += 2;
		} else {
			*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);
		}
		goto LABEL_45;
	}

LABEL_44:
	*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_);

LABEL_45:


	pDest += 2;
	BitCount --;

	if ( !((BitsBuffer >> BitCount) & 1) )
	{
		BitCount--; 
		if ( (BitsBuffer >> BitCount) & 1 ) 
		{
			offset_ = *(unsigned char *)pBlock2++; 
		} else {
			offset_ = *(unsigned short *)pIn;
			pIn += 2;
		}
	}
	if ( Shift & 8 )
	{
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_);
	} else {

		BitCount--; 
		if ( (BitsBuffer >> BitCount) & 1 )
		{
			*(unsigned short *)pDest = *(unsigned short *)pIn;
			pIn += 2;
		} else {
			
			*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);
		}
	}
	pDest += 2;


	if ( Shift & 4 ) 
	{
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_);
	} else { 

		BitCount--; 
			if ( (BitsBuffer >> BitCount) & 1 )
			{
				*(unsigned short *)pDest = *(unsigned short *)pIn;
				pIn += 2;
			} else {
			
			*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);
		}
	}
	BitCount = BitCount - 1; 
	pDest += 2;

	if ( !((BitsBuffer >> BitCount) & 1) )
	{
		BitCount--; 
		if ( (BitsBuffer >> BitCount) & 1 ) 
		{
			offset_ = *(unsigned char *)pBlock2++;
			
		} else {
			offset_ = *(unsigned short *)pIn;
			pIn += 2;
		}
	}
	if ( Shift & 2 ) 
	{
		*(unsigned short *)pDest = *(unsigned short *)(pDest - 2 * offset_);
	} else {
		BitCount--;
		if ( (BitsBuffer >> BitCount) & 1 ) 
		{
			*(unsigned short *)pDest = *(unsigned short *)pIn; 
			pIn += 2;
		} else {
			
			*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_); 
		}
	}
	pDest += 2;
	if ( !(Shift & 1) ) 
	{
		BitCount--; 
	if ( (BitsBuffer >> BitCount) & 1 )
	{
		*(unsigned short *)pDest = *(unsigned short *)pIn;
		pIn += 2;
	} else { 
		 
		*(unsigned short *)pDest = difftableQMG[*(unsigned char *)pBlock2++] ^ *(unsigned short *)(pDest - 2 * offset_);
	} 
	pDest += 2;
	goto LABEL_61;
	}
	v44 = *(unsigned short *)(pDest - 2 * offset_);
LABEL_59: 
	*(unsigned short *)pDest = v44;
LABEL_60: 
	pDest = pDest + 2;
LABEL_61:

	int a = *(unsigned int *)(pDest - 16);
	int b = *(unsigned int *)(pDest - 12);
	int c = *(unsigned int *)(pDest - 8);
	int d = *(unsigned int *)(pDest - 4);


	Count += 4; 
}







unsigned int CountByte = 4 * CountDword; 
 if ( (unsigned int)(4 * CountDword) < first ) 
 {
	 memcpy((void *)pDest, pBlock2, first - CountByte); 
	 result = first + 4 * Count - CountByte; 
 } else {
	 result = first + 4 * Count - CountByte;
 } 


 return result;


//return 1;
}

int QM_WCodec_1st_decode(unsigned char* src, unsigned char* dst, /* int a3, int a4, int a5, int a6,*/ int HmW, int _2or4) { 
	
	 int CounBloc1 = 0;
	 int CounBloc2 = 0; // ebx@1 
	 int CounDst = 0; // edi@1 
	 unsigned char* pBloc1; // esi@1 
	 unsigned char* v12; // eax@1 
	 unsigned char* v13; // eax@1 
	 unsigned char i; // edx@3 
	 int CounBloc3 = 0; // eax@6 
	 int v16; // eax@9 
	 char v17; // zf@9 
	 int v19; // eax@11 
	 unsigned char v20; // eax@11 
//	 unsigned __int8 k; // sf@13 
//	 unsigned __int8 v22; // of@13
	 int v23; // [sp+0h] [bp-38h]@8 
	 int v24; // [sp+8h] [bp-30h]@8 
	 int j; // [sp+8h] [bp-30h]@11
//	 signed int v26; // [sp+Ch] [bp-2Ch]@13 
	 int v27; // [sp+10h] [bp-28h]@1 
	 int v28; // [sp+14h] [bp-24h]@1 
//	 int v29; // [sp+18h] [bp-20h]@1 
	 int v30; // [sp+1Ch] [bp-1Ch]@11
	 unsigned char* pBloc3; // [sp+24h] [bp-14h]@1 
	 unsigned char* pBloc2; // [sp+28h] [bp-10h]@1 
	
	int a3 = WORD(src,0);
	int a4 = WORD(src,4);
	int a5 = WORD(src,8);
//	int d = WORD(dst,0xc);


//	 v29 = 0; 
//	 v9 = 0; 
	 v27 = HmW * _2or4 & 3; 
	 v28 = HmW * _2or4 >> 2;
//	 CounBloc1 = 0; 
	 v12 = (unsigned char*)(src + 4 * a3); 
	 pBloc1 = v12 + 16; //11
	 v13 = a4 + v12; 
	 pBloc2 = v13 + 16; //32
//	 v10 = 0; 
	 pBloc3 = a5 + pBloc2; //31
	 while ( CounDst < v28 )
	 {
		 while ( 1 ) 
		 {
//			 i = *(signed char *)(pBloc1 + CounBloc1); 
//			 CounBloc1++;
			
			for ( i = *(unsigned char *)(pBloc1 + CounBloc1++)/**(unsigned char *)(v8++ + v11)*/; *(signed char *)(pBloc1 + CounBloc1 - 1) == 0xFF; CounBloc1++ )
				i += *(unsigned char *)(pBloc1 + CounBloc1);		 
			 
			 if ( i ) //offset_ from src if i > 0
				 break;
//goto LABEL_6;

			 *(unsigned int *)(dst + 4 * CounDst) = *(unsigned int *)(pBloc3 + 4 * CounBloc3);
			 CounDst++; CounBloc3++;
			 if ( CounDst >= v28 )
				 
				 goto LABEL_7;
		 } 
//LABEL_6:		
		 //  1 = 0     3    0     src  FF     
		 *(unsigned int *)(dst + 4 * CounDst) = *(unsigned int *)(src + 16 + 4 * i - 4);

		v30 = *(unsigned int *)(dst + 4 * CounDst);
		CounDst++;
		v20 = *(unsigned char *)(pBloc2 + CounBloc2); 
		CounBloc2++;

		 for ( j = v20; *(unsigned char *)(pBloc2 + CounBloc2 - 1) == 0xFF; CounBloc2++ )
			 j += *(unsigned char *)(CounBloc2 + pBloc2);
		 
		 int v = 0;
			 //if(j){
				while(v<j ){
					//j--;
					 *(unsigned int *)(dst + 4 * CounDst) = v30; 
						CounDst++; v++;
				 } 
			 //}
	 }

LABEL_7:
	 if ( v27 )
	 {
		 v23 = HmW * _2or4 & 3;
		 v24 = 4 * v28;
	 do 
	 {
		 //v16 = CounBloc1++;
		 *(unsigned char *)(v24 + dst) = *(unsigned char *)(pBloc1 + CounBloc1++);
		 v17 = v23-- == 1;
		 ++v24; 
	 }
	 while ( !v17 );
	 }
	 return v27 + 4 * CounDst; 
}


	int _QM_WCodec_1st_decode ( unsigned char *src, unsigned char *dst, unsigned short H, unsigned short W, unsigned int _2or4/*, BackgroundWorker ^ bwAsync*/ )
	{

		unsigned int HmW = H*W;

		return QM_WCodec_1st_decode( src,  dst,  HmW, _2or4);


	}

	void/*array<unsigned char>^*/ DecompressQMG ( array<unsigned char>^ buffer/*, BackgroundWorker ^ bwAsync*/, PictureBox^ pictureBox1)
	{
		
	
		unsigned int length = buffer->Length;
		
		unsigned char *src = ( unsigned char *)malloc ( length );
		
		Marshal::Copy(buffer, 0, IntPtr(src), buffer->Length);

		unsigned short W = *(unsigned short*)(src + 0x6);
		unsigned short H = *(unsigned short*)(src + 0x8);
		unsigned int _2or4 = 4;
		unsigned int dst_len = H*W*_2or4;
		
		src = src + 0x10;

		unsigned char *dst = ( unsigned char *)malloc ( dst_len + 0x100000);////////////////
		int len1 = QM_WCodec_2nd_decode(src, dst);
		
		unsigned char *dst2 = ( unsigned char *)malloc ( dst_len  + 0x100000);////////////////
		unsigned int len2 = _QM_WCodec_1st_decode(dst,dst2,H,W,_2or4);


		//unsigned int decompress_len;
		//= qmd_get_decompress_size ( src );
//		array<unsigned char>^ decompress = gcnew array<unsigned char>( dst_len );
		
//		Marshal::Copy(IntPtr(dst), decompress, 0,  dst_len);

		Bitmap^ bmp = gcnew Bitmap(W, H, Imaging::PixelFormat::Format32bppPArgb);
				Rectangle rect = Rectangle(0,0,W,H);
					System::Drawing::Imaging::BitmapData^ bmpData = bmp->LockBits( rect, System::Drawing::Imaging::ImageLockMode::ReadWrite, bmp->PixelFormat );
						IntPtr ptr = bmpData->Scan0;
							int bytes = Math::Abs(bmpData->Stride) * H;
								memcpy( (void*)(ptr), dst2, bytes);
					
						bmp->UnlockBits( bmpData );
						pictureBox1->SizeMode = PictureBoxSizeMode::CenterImage;
					pictureBox1->Image = dynamic_cast<Image^>(bmp);


		free( src );
		free ( dst );
		free ( dst2 );

//		return decompress;
	}








}